# Python Connector for xBase #

Python Connector for xBase is a connectivity solution for accessing FoxPro,
Visual FoxPro, dBase, and other databases in DBF file formats from Python
applications. It fully implements the Python DB API 2.0 specification.
The connector is distributed as a wheel package for Windows, macOS, and Linux.
 
Direct connection
 
The connector enables you to establish a direct connection to Visual
FoxPro, dBase, and other xBase databases eliminating the need
for the client library. A direct connection increases the speed of data
transmission between a Python application and an xBase database and
simplifies the deployment.
 
Local indexing
 
The connector offers an internal data indexing mechanism that is way more
efficient than native DBF indexes for complex queries.
 
Retrieval of corrupted data
 
You can choose to ignore corrupted data and metadata errors in DBF tables.
Corrupted data is skipped, while intact data is properly retrieved.

## Using the connector ##

To retrieve data from a database:
 
Import the module.
 
```
import devart.xbase
```
 
Connect to a database using the `connect()` module method and obtain a `connection` object.
 
```
my_connection = devart.xbase.connect(
    Database="your_db_path"
)
```
 
Create a `cursor` object using the `cursor()` connection method.
 
```
my_cursor = my_connection.cursor()
```
 
Execute the SQL statement using the `execute()` cursor method.
 
```
my_cursor.execute("SELECT * FROM employees")
```
 
Retrieve the result set using one of the `fetch*()` cursor methods.
 
```
for row in my_cursor.fetchall(): 
    print(row)
```

## What's new ##

Python Connector for xBase 1.0
 
* Initial release of Python Connector for xBase
* Added support for Windows 32-bit and 64-bit
* Added support for Windows Server 32-bit and 64-bit
* Added support for macOS 64-bit and ARM (Apple M1 and M2)
* Added support for Linux 64-bit
